import os
import string
import smtplib
import random
from email.mime.text import MIMEText
from email.mime.multipart import MIMEMultipart

BASE_DIR = os.path.dirname(os.path.abspath(__file__))
CUSTOMERS_FILE = os.path.join(BASE_DIR, "customers.txt")

# Functions for Admins

def createUser(username, fullName, email, password):
    if not os.path.exists(CUSTOMERS_FILE):
        open(CUSTOMERS_FILE, 'w').close()

    found = False
    with open(CUSTOMERS_FILE, 'r') as file:
        data = file.readlines()
        for line in data:
            user = line.strip('\n')
            userInfo = user.split(',')
            if username == userInfo[0]:
                print(f"User {username} Already Exists!")
                found = True
                break
            elif email == userInfo[2]:
                print(f"Email `{email}` is already registered with an account!")
                found = True
                break
        if found == False:
            with open(CUSTOMERS_FILE, 'a') as file:
                file.write(f'{username},{fullName},{email},False,{password}\n')

def findUser(username):
    found = False
    clutter = 0
    with open(CUSTOMERS_FILE, 'r') as file:
        data = file.readlines()
        for line in data:
            user = line.strip('\n')
            userInfo = user.split(',')
            if username == userInfo[0]:
                print(f"User Found at {clutter + 1}th place.")
                found = True
                return clutter+1
                break
            clutter+=1
        if found == False:
            print("User Not Found!")

def verifyUser(username, senderMail, senderPassword):
    recipient_mail = ''
    with open(CUSTOMERS_FILE, 'r') as file:
        data = file.readlines()
        for line in data:
            user = line.strip('\n')
            userInfo = user.split(',')
            if username == userInfo[0]:
                recipient_mail = userInfo[2]
                fullName = userInfo[1]
                password = userInfo[4]
                break
    
    length = 6
    characters = string.digits
    otp = ''.join(random.choice(characters) for _ in range(length))

    subject = "Your Verification Code"
    body = f"Your verification code is: {otp}"

    msg = MIMEMultipart()
    msg['From'] = senderMail
    msg['To'] = recipient_mail
    msg['Subject'] = subject
    msg.attach(MIMEText(body, 'plain'))

    try:
        verified = False
        server = smtplib.SMTP('smtp.gmail.com', 587)
        server.starttls()
        server.login(senderMail, senderPassword)
        server.send_message(msg, senderMail, recipient_mail)
        server.quit()
        print(f"OTP sent to {recipient_mail}")
        checkOTP = input("Enter The OTP recieved : ")
        if checkOTP == otp:
            print("User Verified Successfuly!")
            verified = True
            with open(CUSTOMERS_FILE, 'r') as file:
                data = file.readlines()
                for line in data:
                    with open(CUSTOMERS_FILE, 'w') as file:
                        if line.strip('\n').split(',')[0] != username:
                            file.write(line)
                        else:
                            file.write(f'{username},{fullName},{recipient_mail},{verified},{password}\n')
        else:
            print("Verification Failed - *Incorrect OTP*")
    except Exception as e:
        print(f"Failed to send email: {e}")

def deleteUser(username, password):
    with open(CUSTOMERS_FILE, 'r') as file:
        data = file.readlines()
    with open(CUSTOMERS_FILE, 'w') as file:
        for line in data:
            if line.strip('\n').split(',')[0] != username:
                file.write(line)
            else:
                if password == line.strip('\n').split(',')[4]:
                    print('User Deleted!')
                    continue
                else:
                    file.write(line)

def editMail(currentMail, newMail, passcode):
    exists = False
    
    if currentMail == newMail:
        print(f"don't play with me you sussy piece of shit.. Both these mails are the same.!!!")
    else:
        with open(CUSTOMERS_FILE, 'r') as file:
            data = file.readlines()

            for line in data:
                user = line.strip('\n')
                userInfo = user.split(',')
                username = userInfo[0]
                fullName = userInfo[1]
                email = userInfo[2]
                verified = userInfo[3]
                password = userInfo[4]

                if email == newMail:
                    print(f"email `{newMail}` is already associated with an account.")
                    exists = True
                    break
                else:
                    continue

            if exists == False:
                found = False
                with open(CUSTOMERS_FILE, 'r') as file:
                    data = file.readlines()
                    with open(CUSTOMERS_FILE, 'w') as file:
                        for line in data:
                        
                            username = line.strip('\n').split(',')[0]
                            fullName = line.strip('\n').split(',')[1]

                            if line.strip('\n').split(',')[2] != currentMail:
                                file.write(line)
                            else:
                                if passcode == password:
                                    file.write(f"{username},{fullName},{newMail},False,{password}\n")
                                    found = True
                                    print('Email Updated!')
                                else:
                                    found = True
                                    print('Invalid Password! Try again later.')
                                    file.write(line)

                        if found == False:
                            print(f"email `{currentMail}` doesn't exists in this database")

def editUsername(currentUsername, newUsername, passcode):
    exists = False

    if currentUsername == newUsername:
        print('error-69: both the usernames are same')
    else:
        with open(CUSTOMERS_FILE, 'r') as file:
            data = file.readlines()

            for line in data:
                user = line.strip('\n')
                userInfo = user.split(',')
                username = userInfo[0]
                fullName = userInfo[1]
                email = userInfo[2]
                verified = userInfo[3]
                password = userInfo[4]

                if username == newUsername:
                    print(f"username `{newUsername}` is already associated with an account.")
                    exists = True
                    break
                else:
                    continue
            
        if exists == False:
            found = False
            with open(CUSTOMERS_FILE, 'r') as file:
                data = file.readlines()
                with open(CUSTOMERS_FILE, 'w') as file:
                    for line in data:

                        username = line.strip('/n').split(',')[0]
                        fullName = line.strip('/n').split(',')[1]

                        if username != currentUsername:
                            file.write(line)
                        else:
                            if passcode == password:
                                file.write(f"{newUsername},{fullName},{email},{verified},{password}")
                                found = True
                                print('Username updated!')
                            else:
                                found = True
                                print('hmm. u look suspicious..')
                                print('error-143 : Invalid Password! Try again later.')
                                file.write(line)
                    if found == False:
                        print(f"username `{currentUsername}` doesn't exists in this database.")

def getUserInfo(username):
    with open(CUSTOMERS_FILE, 'r') as file:
        data = file.readlines()

        for line in data:
            userInfo = line.strip('\n').split(',')
            userName = userInfo[0]
            fullName = userInfo[1]
            email = userInfo[2]
            verified = userInfo[3]

            if username == userName:
                print('!!- User Found -!!')
                print(f'Username : {userName}')
                print(f"Full Name : {fullName}")
                print(f"Email : {email}")
                print(f"Verified Account? : {verified}")
            else:
                print('!!=- User Not Found -=!!')

def getRawData():
    print('Username | Full Name | E-Mail | Verified? | Password')
    with open(CUSTOMERS_FILE, 'r') as file:
        data = file.read()
        print(data)
        return data

def clearDB():
    with open(CUSTOMERS_FILE, 'w') as file:
        file.write('')